#!/usr/bin/perl -w

# This script loads up an NSArray from an plist on disk
# and then downloads each file named in the array from the
# TidBITS FTP site and stores it in the default location
# on disk.

use strict;

use lib '__modules_path__';
use Net::FTP;
use Foundation;


# We'll be reading our input from here.
# We use Cocoa to expand our user path to a full path.
# Cocoa's path routines will cut off a trailing slash so we append it after.

my $base_path = "~/Library/Application Support/XBit";
$base_path = NSString->stringWithCString_($base_path)->stringByExpandingTildeInPath()->cString();
$base_path = $base_path . "/";
#print $base_path . "\n";

my $file_name = "issue_listing.plist";

my $path;


# Get a list of strings from a plist file.

$path = $base_path . $file_name;
#print $path . "\n";
my $cocoa_array = NSArray->arrayWithContentsOfFile_($path);


# The FTP voodoo starts here.

my $ftp = Net::FTP->new( "ftp.tidbits.com", Debug => 0 )
	or die "Cannot connect to host: $@";

$ftp->login( "anonymous", '-anonymous@' )
	or die "Cannot login ", $ftp->message;

#$ftp->cwd( "/issues/2003" )
#	or die "Cannot change working directory ", $ftp->message;

my $name;
my $i;

for ($i = 0; $i < $cocoa_array->count(); $i++ )
	{
	$name = $cocoa_array->objectAtIndex_($i)->cString();
	$path = $base_path . "TidBITS/" . $cocoa_array->objectAtIndex_($i)->lastPathComponent()->cString();
	$name = $ftp->get($name, $path)
		or die "get failed ", $ftp->message;
	print $name . "\n";
	}

$ftp->quit;
